﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Web;
using System.Web.Services.Protocols;

namespace MySoapLib {
    public sealed class SoapClientMessage : SoapMessage {
        // Fields
        internal SoapExtension[] initializedExtensions;
        private SoapClientMethod method;
        private SoapHttpClientProtocol protocol;
        private string url;

        //// Methods
        //internal SoapClientMessage(SoapHttpClientProtocol protocol, SoapClientMethod method, string url) {
        //    this.method = method;
        //    this.protocol = protocol;
        //    this.url = url;
        //}
        // Methods
        internal SoapClientMessage(SoapClientMethod method, string url) {
            this.method = method;
            this.url = url;
        }

        protected override void EnsureInStage() {
            base.EnsureStage(SoapMessageStage.BeforeSerialize);
        }

        protected override void EnsureOutStage() {
            base.EnsureStage(SoapMessageStage.AfterDeserialize);
        }

        // Properties
        public override string Action {
            get {
                return this.method.action;
            }
        }

        public SoapHttpClientProtocol Client {
            get {
                return this.protocol;
            }
        }

        internal SoapClientMethod Method {
            get {
                return this.method;
            }
        }

        public override LogicalMethodInfo MethodInfo {
            get {
                return this.method.methodInfo;
            }
        }

        public override bool OneWay {
            get {
                return this.method.oneWay;
            }
        }

        [ComVisible(false)]
        public override SoapProtocolVersion SoapVersion {
            get {
                if (this.protocol.SoapVersion != SoapProtocolVersion.Default) {
                    return this.protocol.SoapVersion;
                }
                return SoapProtocolVersion.Soap11;
            }
        }

        public override string Url {
            get {
                return this.url;
            }
        }
    }


}
